<template>
    <div>
  <div class="page-title">
    <h3>История записей</h3>
  </div>

  <div class="history-chart">
    <canvas :ref="canvas"></canvas>
  </div>

<Loader v-if="loading" />
<p class="center" v-else-if="!records.length">Records is empty</p>
  <section v-else>
    <HistoryTable :records="items" />

    <Paginate v-model="page"
              :page-count="pageCount"
              :page-range="3"
              :margin-pages="2"
              :click-handler="pagechangeHandler"
              :prev-text="'Prev'"
              :next-text="'Next'"
              :container-class="'pagination'"
              :page-class="'waves-effect'">
    </Paginate>
  </section>
</div>
</template>

<script>
import HistoryTable from '@/components/HistoryTable'
import paginationMixin from '@/mixins/pagination.mixin'
import {Pie} from 'vue-chartjs'

export default {
  name:'history',
  extends: Pie,
  mixins:[paginationMixin],
  data: ()=>({
    loading: true,
    records: []
  }),
  async mounted(){
    this.records = await this.$store.dispatch('fetchRecords');
    const categories= await this.$store.dispatch('fetchCategories');

    this.setup(categories);

    this.loading=false;
  },
  methods:{
    setup(categories){
      this.setupPagination(this.records.map(record=>{
        return{
          ...record,
          categoryName:categories.find(c=>c.id===record.categoryId).title,
          typeClass: record.type === 'income' ? 'green':'red',
          typeText: record.type === 'income' ? 'Doxod':'Rasxod',
        }
      }));

      // this.renderChart({
      //   labels:categories.map(c=>c.title),
      //   datasets:[{
      //     label: 'Rasxod by category',
      //     data:categories.map(c=>{
      //       return this.records.reduce((total, r) =>{
      //         if(r.categoryId === c.id && r.type==='outcome'){
      //           total += +r.amount;
      //         }
      //         return total;
      //       },0)
      //     }),
      //     //backgroundColor:[]
      //   }]
      // });
    }
  },
  components:{
    HistoryTable
  }
}
</script>
